Imports Outlook = Microsoft.Office.Interop.Outlook
Imports System.Reflection
Imports System.Runtime.InteropServices
Imports System.ComponentModel

<ComVisible(True)> _
Public Class FolderPP
    Implements Outlook.PropertyPage

    Private m_dirty As Boolean
    Private m_site As Outlook.PropertyPageSite

    Private m_caption As String

    Public Sub Apply() Implements Microsoft.Office.Interop.Outlook.PropertyPage.Apply
        If m_dirty Then
            'do something to save properties

            'clear the dirty flag
            m_dirty = False
        End If
    End Sub

    Public ReadOnly Property Dirty() As Boolean Implements Microsoft.Office.Interop.Outlook.PropertyPage.Dirty
        Get
            Dirty = m_dirty
        End Get
    End Property

    Public Sub GetPageInfo(ByRef HelpFile As String, ByRef HelpContext As Integer) Implements Microsoft.Office.Interop.Outlook.PropertyPage.GetPageInfo
        'show help file here
    End Sub

    Private Sub FolderPP_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        ' HACK: uses reflection to call a private unsafe method!
        Dim userControlType As Type = GetType(Windows.Forms.UserControl)
        Dim oleObjectType As Type = userControlType.Assembly.GetType("System.Windows.Forms.UnsafeNativeMethods+IOleObject")
        Dim method As MethodInfo = oleObjectType.GetMethod("GetClientSite")

        m_site = TryCast(method.Invoke(Me, Nothing), Outlook.PropertyPageSite)
    End Sub

    Private Sub SetDirty()
        m_dirty = True

        If m_site IsNot Nothing Then
            m_site.OnStatusChange()
        End If
    End Sub

    <DispId(-518)> _
     Public Overrides Property Text() As String
        Get
            Return m_caption
        End Get
        Set(ByVal value As String)
            m_caption = value
        End Set
    End Property
End Class
